//
// Omega Tradestation 8 EasyLanguage ELD pr0tection template.
// Public Release.
//

// Copyright (C) 2004 VizibleSoft Ltd.
// http://viziblesoft.com
// All rights reserved.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// The "GNU General Public License" (GPL) is available at
// http://www.gnu.org/copyleft/gpl.html.
//
// $Id: pr0t.cpp,v 1.0 2004/08/23 19:59:13 Exp $
// ################################################################


#include <math.h>
#include <string.h>
#include "stdafx.h"
#include "pr0t.h"


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// exported functions

api_entry(int) pr0tinit(IEasyLanguageObject *pEL)
{

	int StateP = pEL->GetTag();
	if (StateP == 0)
	{
		StateP = 123;	
		pEL->Tag = (int)StateP;
	}

	return 0;
}

api_entry(int) pr0tdone(IEasyLanguageObject *pEL)
{

	int StateP = pEL->GetTag();
	if (StateP != 0)
	{
		pEL->Tag = 0;
	}

	return 0;
}

api_entry(double) myOpen(IEasyLanguageObject *pEL, int nBarsBack)
{
	return pEL->Open[nBarsBack]; 
}

api_entry(double) myClose(IEasyLanguageObject *pEL, int nBarsBack)
{
	return pEL->Close[nBarsBack]; 
}

api_entry(double) myHigh(IEasyLanguageObject *pEL, int nBarsBack)
{
return pEL->High[nBarsBack]; 
}

api_entry(double) myLow(IEasyLanguageObject *pEL, int nBarsBack)
{
return pEL->Low[nBarsBack]; 
}

api_entry(double) myCurrentBar(IEasyLanguageObject *pEL, EN_DATA_STREAM dt)
{
return pEL->CurrentBar[dt];
}
	
api_entry(double) myDateTime(IEasyLanguageObject *pEL, int nBarsBack)
{
return pEL->DateTime[nBarsBack];
}

api_entry(double) myTrueHigh(IEasyLanguageObject *pEL, int Bar, EN_DATA_STREAM dt)
{
	return pEL->HighMD[dt]->AsDouble[Bar] > pEL->CloseMD[dt]->AsDouble[Bar+1] ? pEL->HighMD[dt]->AsDouble[Bar] : pEL->CloseMD[dt]->AsDouble[Bar+1];
}

api_entry(double) myTrueLow(IEasyLanguageObject *pEL, int Bar, EN_DATA_STREAM dt)
{
	return pEL->LowMD[dt]->AsDouble[Bar] < pEL->CloseMD[dt]->AsDouble[Bar+1] ? pEL->LowMD[dt]->AsDouble[Bar] : pEL->CloseMD[dt]->AsDouble[Bar+1];
}

api_entry(double) myTrueRange(IEasyLanguageObject *pEL, int Bar, EN_DATA_STREAM dt)
{
	return myTrueHigh(pEL, Bar, dt) - myTrueLow(pEL, Bar, dt);
}



api_entry(double) myTime(IEasyLanguageObject *pEL)
{
	int min = pEL->DateTimeMD[dataDefault]->Minutes[0];
	int hours = pEL->DateTimeMD[dataDefault]->Hour[0];
	return (hours * 100) + min;
}


// This procedure can be used to check allowed Customer ID and other registration info

api_entry(double) chkLicense(IEasyLanguageObject *pEL, char* extLicenseInfo, int CustomerID)
{

    int AllowedCustomerID = 123456;

    if(CustomerID != AllowedCustomerID) return -1; // error

    {

      do other licensing stuff
    }

	
	return 45091313; // initialized successfully.
}


double __stdcall GetVarByName(IEasyLanguageObject *pEL, char* varName)
{
	IEasyLanguageVariable *pELVar = pEL->Variables[varName];
	return pELVar->AsDouble[0] ;
}


api_entry(int) myDayOfWeek(IEasyLanguageObject *pEL) {

	int dooms[12] = {31, 28, 7, 4, 9, 6, 11, 8, 5, 10, 7, 12};
	int day, month, year, y, ddcentury, weekday;
	IEasyLanguageDateTime *pELDT = pEL->DateTimeMD[dataDefault];

	day = pELDT->Day[0];
	month = pELDT->Month[0];
	year = pELDT->Year[0];


	int ddmonth = dooms[month-1];
	if( ((year % 4) == 0) && ((month == 1) || (month == 2)) ) ddmonth++;

	int century = year - (year % 100);
	if(century < 2000) ddcentury = 3;
	if(century < 2100) ddcentury = 2;


	if(ddmonth > day)
            weekday = (7 - ((ddmonth-day) % 7 ) + ddmonth);
        else
            weekday = day;

	int x = (weekday - ddmonth);
	x %= 7;
	y = int (ddcentury + (year-century) + (floor((year-century)/4)));
	y %= 7;
	x = (x+y)%7;
	return x;
}


api_entry(BOOL) Cond(IEasyLanguageObject *pEL, int i, int ARGUMENT)
{
	switch(i) {

	case 1:
		return GetVarByName(pEL, "myVar1") > (GetVarByName(pEL, "myVar2") - 1) ? TRUE : FALSE;
	case 2:
		return myTime(pEL) == 1300 ? TRUE : FALSE;
	case 3:
		return myDayOfWeek(pEL) == ARGUMENT ? TRUE : FALSE;
	default:
		return TRUE;
	}
}


// internal functions

double TrueRangeAverage(IEasyLanguageObject *pEL, int Bars, EN_DATA_STREAM dt)
{
	double tr = 0;
	for(int i=0;i<Bars;i++)
		tr += myTrueRange(pEL, i, dt);

	return (tr / Bars);
}

double RangeAverage(IEasyLanguageObject *pEL, int Bars, EN_DATA_STREAM dt) 
{
	double tr = 0;
	for(int i=0;i<Bars;i++)
		tr += pEL->HighMD[dt]->AsDouble[i] - pEL->LowMD[dt]->AsDouble[i];

	return (tr / Bars);
}
